t / test-lib.shon commit Makefile: add helper for compiling with -fsanitize (56b5db3)
   1# Test framework for git.  See t/README for usage.
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Test the binaries we have just built.  The tests are kept in
  19# t/ subdirectory and are run in 'trash directory' subdirectory.
  20if test -z "$TEST_DIRECTORY"
  21then
  22        # We allow tests to override this, in case they want to run tests
  23        # outside of t/, e.g. for running tests on the test library
  24        # itself.
  25        TEST_DIRECTORY=$(pwd)
  26else
  27        # ensure that TEST_DIRECTORY is an absolute path so that it
  28        # is valid even if the current working directory is changed
  29        TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
  30fi
  31if test -z "$TEST_OUTPUT_DIRECTORY"
  32then
  33        # Similarly, override this to store the test-results subdir
  34        # elsewhere
  35        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  36fi
  37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  38
  39# If we were built with ASAN, it may complain about leaks
  40# of program-lifetime variables. Disable it by default to lower
  41# the noise level. This needs to happen at the start of the script,
  42# before we even do our "did we build git yet" check (since we don't
  43# want that one to complain to stderr).
  44: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
  45export ASAN_OPTIONS
  46
  47################################################################
  48# It appears that people try to run tests without building...
  49"$GIT_BUILD_DIR/git" >/dev/null
  50if test $? != 1
  51then
  52        echo >&2 'error: you do not seem to have built git yet.'
  53        exit 1
  54fi
  55
  56. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  57export PERL_PATH SHELL_PATH
  58
  59# if --tee was passed, write the output not only to the terminal, but
  60# additionally to the file test-results/$BASENAME.out, too.
  61case "$GIT_TEST_TEE_STARTED, $* " in
  62done,*)
  63        # do not redirect again
  64        ;;
  65*' --tee '*|*' --va'*|*' --verbose-log '*)
  66        mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
  67        BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
  68
  69        # Make this filename available to the sub-process in case it is using
  70        # --verbose-log.
  71        GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
  72        export GIT_TEST_TEE_OUTPUT_FILE
  73
  74        # Truncate before calling "tee -a" to get rid of the results
  75        # from any previous runs.
  76        >"$GIT_TEST_TEE_OUTPUT_FILE"
  77
  78        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  79         echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
  80        test "$(cat "$BASE.exit")" = 0
  81        exit
  82        ;;
  83esac
  84
  85# For repeatability, reset the environment to known value.
  86# TERM is sanitized below, after saving color control sequences.
  87LANG=C
  88LC_ALL=C
  89PAGER=cat
  90TZ=UTC
  91export LANG LC_ALL PAGER TZ
  92EDITOR=:
  93# A call to "unset" with no arguments causes at least Solaris 10
  94# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  95# deriving from the command substitution clustered with the other
  96# ones.
  97unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  98        my @env = keys %ENV;
  99        my $ok = join("|", qw(
 100                TRACE
 101                DEBUG
 102                USE_LOOKUP
 103                TEST
 104                .*_TEST
 105                PROVE
 106                VALGRIND
 107                UNZIP
 108                PERF_
 109                CURL_VERBOSE
 110                TRACE_CURL
 111        ));
 112        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
 113        print join("\n", @vars);
 114')
 115unset XDG_CONFIG_HOME
 116unset GITPERLLIB
 117GIT_AUTHOR_EMAIL=author@example.com
 118GIT_AUTHOR_NAME='A U Thor'
 119GIT_COMMITTER_EMAIL=committer@example.com
 120GIT_COMMITTER_NAME='C O Mitter'
 121GIT_MERGE_VERBOSITY=5
 122GIT_MERGE_AUTOEDIT=no
 123export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 124export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 125export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 126export EDITOR
 127
 128# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
 129GIT_TRACE_BARE=1
 130export GIT_TRACE_BARE
 131
 132if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
 133then
 134        GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
 135        export GIT_INDEX_VERSION
 136fi
 137
 138# Add libc MALLOC and MALLOC_PERTURB test
 139# only if we are not executing the test with valgrind
 140if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 141   test -n "$TEST_NO_MALLOC_CHECK"
 142then
 143        setup_malloc_check () {
 144                : nothing
 145        }
 146        teardown_malloc_check () {
 147                : nothing
 148        }
 149else
 150        setup_malloc_check () {
 151                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 152                export MALLOC_CHECK_ MALLOC_PERTURB_
 153        }
 154        teardown_malloc_check () {
 155                unset MALLOC_CHECK_ MALLOC_PERTURB_
 156        }
 157fi
 158
 159# Protect ourselves from common misconfiguration to export
 160# CDPATH into the environment
 161unset CDPATH
 162
 163unset GREP_OPTIONS
 164unset UNZIP
 165
 166case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1671|2|true)
 168        GIT_TRACE=4
 169        ;;
 170esac
 171
 172# Convenience
 173#
 174# A regexp to match 5 and 40 hexdigits
 175_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 176_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 177
 178# Zero SHA-1
 179_z40=0000000000000000000000000000000000000000
 180
 181EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 182EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
 183
 184# Line feed
 185LF='
 186'
 187
 188# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
 189# when case-folding filenames
 190u200c=$(printf '\342\200\214')
 191
 192export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
 193
 194# Each test should start with something like this, after copyright notices:
 195#
 196# test_description='Description of this test...
 197# This test checks if command xyzzy does the right thing...
 198# '
 199# . ./test-lib.sh
 200test "x$TERM" != "xdumb" && (
 201                test -t 1 &&
 202                tput bold >/dev/null 2>&1 &&
 203                tput setaf 1 >/dev/null 2>&1 &&
 204                tput sgr0 >/dev/null 2>&1
 205        ) &&
 206        color=t
 207
 208while test "$#" -ne 0
 209do
 210        case "$1" in
 211        -d|--d|--de|--deb|--debu|--debug)
 212                debug=t; shift ;;
 213        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 214                immediate=t; shift ;;
 215        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 216                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 217        -r)
 218                shift; test "$#" -ne 0 || {
 219                        echo 'error: -r requires an argument' >&2;
 220                        exit 1;
 221                }
 222                run_list=$1; shift ;;
 223        --run=*)
 224                run_list=${1#--*=}; shift ;;
 225        -h|--h|--he|--hel|--help)
 226                help=t; shift ;;
 227        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 228                verbose=t; shift ;;
 229        --verbose-only=*)
 230                verbose_only=${1#--*=}
 231                shift ;;
 232        -q|--q|--qu|--qui|--quie|--quiet)
 233                # Ignore --quiet under a TAP::Harness. Saying how many tests
 234                # passed without the ok/not ok details is always an error.
 235                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 236        --with-dashes)
 237                with_dashes=t; shift ;;
 238        --no-color)
 239                color=; shift ;;
 240        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 241                valgrind=memcheck
 242                shift ;;
 243        --valgrind=*)
 244                valgrind=${1#--*=}
 245                shift ;;
 246        --valgrind-only=*)
 247                valgrind_only=${1#--*=}
 248                shift ;;
 249        --tee)
 250                shift ;; # was handled already
 251        --root=*)
 252                root=${1#--*=}
 253                shift ;;
 254        --chain-lint)
 255                GIT_TEST_CHAIN_LINT=1
 256                shift ;;
 257        --no-chain-lint)
 258                GIT_TEST_CHAIN_LINT=0
 259                shift ;;
 260        -x)
 261                trace=t
 262                verbose=t
 263                shift ;;
 264        --verbose-log)
 265                verbose_log=t
 266                shift ;;
 267        *)
 268                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 269        esac
 270done
 271
 272if test -n "$valgrind_only"
 273then
 274        test -z "$valgrind" && valgrind=memcheck
 275        test -z "$verbose" && verbose_only="$valgrind_only"
 276elif test -n "$valgrind"
 277then
 278        verbose=t
 279fi
 280
 281if test -n "$color"
 282then
 283        # Save the color control sequences now rather than run tput
 284        # each time say_color() is called.  This is done for two
 285        # reasons:
 286        #   * TERM will be changed to dumb
 287        #   * HOME will be changed to a temporary directory and tput
 288        #     might need to read ~/.terminfo from the original HOME
 289        #     directory to get the control sequences
 290        # Note:  This approach assumes the control sequences don't end
 291        # in a newline for any terminal of interest (command
 292        # substitutions strip trailing newlines).  Given that most
 293        # (all?) terminals in common use are related to ECMA-48, this
 294        # shouldn't be a problem.
 295        say_color_error=$(tput bold; tput setaf 1) # bold red
 296        say_color_skip=$(tput setaf 4) # blue
 297        say_color_warn=$(tput setaf 3) # brown/yellow
 298        say_color_pass=$(tput setaf 2) # green
 299        say_color_info=$(tput setaf 6) # cyan
 300        say_color_reset=$(tput sgr0)
 301        say_color_="" # no formatting for normal text
 302        say_color () {
 303                test -z "$1" && test -n "$quiet" && return
 304                eval "say_color_color=\$say_color_$1"
 305                shift
 306                printf "%s\\n" "$say_color_color$*$say_color_reset"
 307        }
 308else
 309        say_color() {
 310                test -z "$1" && test -n "$quiet" && return
 311                shift
 312                printf "%s\n" "$*"
 313        }
 314fi
 315
 316TERM=dumb
 317export TERM
 318
 319error () {
 320        say_color error "error: $*"
 321        GIT_EXIT_OK=t
 322        exit 1
 323}
 324
 325say () {
 326        say_color info "$*"
 327}
 328
 329if test -n "$HARNESS_ACTIVE"
 330then
 331        if test "$verbose" = t || test -n "$verbose_only"
 332        then
 333                printf 'Bail out! %s\n' \
 334                 'verbose mode forbidden under TAP harness; try --verbose-log'
 335                exit 1
 336        fi
 337fi
 338
 339test "${test_description}" != "" ||
 340error "Test script did not set test_description."
 341
 342if test "$help" = "t"
 343then
 344        printf '%s\n' "$test_description"
 345        exit 0
 346fi
 347
 348exec 5>&1
 349exec 6<&0
 350exec 7>&2
 351if test "$verbose_log" = "t"
 352then
 353        exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
 354elif test "$verbose" = "t"
 355then
 356        exec 4>&2 3>&1
 357else
 358        exec 4>/dev/null 3>/dev/null
 359fi
 360
 361# Send any "-x" output directly to stderr to avoid polluting tests
 362# which capture stderr. We can do this unconditionally since it
 363# has no effect if tracing isn't turned on.
 364#
 365# Note that this sets up the trace fd as soon as we assign the variable, so it
 366# must come after the creation of descriptor 4 above. Likewise, we must never
 367# unset this, as it has the side effect of closing descriptor 4, which we
 368# use to show verbose tests to the user.
 369#
 370# Note also that we don't need or want to export it. The tracing is local to
 371# this shell, and we would not want to influence any shells we exec.
 372BASH_XTRACEFD=4
 373
 374test_failure=0
 375test_count=0
 376test_fixed=0
 377test_broken=0
 378test_success=0
 379
 380test_external_has_tap=0
 381
 382die () {
 383        code=$?
 384        if test -n "$GIT_EXIT_OK"
 385        then
 386                exit $code
 387        else
 388                echo >&5 "FATAL: Unexpected exit with code $code"
 389                exit 1
 390        fi
 391}
 392
 393GIT_EXIT_OK=
 394trap 'die' EXIT
 395trap 'exit $?' INT
 396
 397# The user-facing functions are loaded from a separate file so that
 398# test_perf subshells can have them too
 399. "$TEST_DIRECTORY/test-lib-functions.sh"
 400
 401# You are not expected to call test_ok_ and test_failure_ directly, use
 402# the test_expect_* functions instead.
 403
 404test_ok_ () {
 405        test_success=$(($test_success + 1))
 406        say_color "" "ok $test_count - $@"
 407}
 408
 409test_failure_ () {
 410        test_failure=$(($test_failure + 1))
 411        say_color error "not ok $test_count - $1"
 412        shift
 413        printf '%s\n' "$*" | sed -e 's/^/#      /'
 414        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 415}
 416
 417test_known_broken_ok_ () {
 418        test_fixed=$(($test_fixed+1))
 419        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 420}
 421
 422test_known_broken_failure_ () {
 423        test_broken=$(($test_broken+1))
 424        say_color warn "not ok $test_count - $@ # TODO known breakage"
 425}
 426
 427test_debug () {
 428        test "$debug" = "" || eval "$1"
 429}
 430
 431match_pattern_list () {
 432        arg="$1"
 433        shift
 434        test -z "$*" && return 1
 435        for pattern_
 436        do
 437                case "$arg" in
 438                $pattern_)
 439                        return 0
 440                esac
 441        done
 442        return 1
 443}
 444
 445match_test_selector_list () {
 446        title="$1"
 447        shift
 448        arg="$1"
 449        shift
 450        test -z "$1" && return 0
 451
 452        # Both commas and whitespace are accepted as separators.
 453        OLDIFS=$IFS
 454        IFS='   ,'
 455        set -- $1
 456        IFS=$OLDIFS
 457
 458        # If the first selector is negative we include by default.
 459        include=
 460        case "$1" in
 461                !*) include=t ;;
 462        esac
 463
 464        for selector
 465        do
 466                orig_selector=$selector
 467
 468                positive=t
 469                case "$selector" in
 470                        !*)
 471                                positive=
 472                                selector=${selector##?}
 473                                ;;
 474                esac
 475
 476                test -z "$selector" && continue
 477
 478                case "$selector" in
 479                        *-*)
 480                                if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
 481                                then
 482                                        echo "error: $title: invalid non-numeric in range" \
 483                                                "start: '$orig_selector'" >&2
 484                                        exit 1
 485                                fi
 486                                if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
 487                                then
 488                                        echo "error: $title: invalid non-numeric in range" \
 489                                                "end: '$orig_selector'" >&2
 490                                        exit 1
 491                                fi
 492                                ;;
 493                        *)
 494                                if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
 495                                then
 496                                        echo "error: $title: invalid non-numeric in test" \
 497                                                "selector: '$orig_selector'" >&2
 498                                        exit 1
 499                                fi
 500                esac
 501
 502                # Short cut for "obvious" cases
 503                test -z "$include" && test -z "$positive" && continue
 504                test -n "$include" && test -n "$positive" && continue
 505
 506                case "$selector" in
 507                        -*)
 508                                if test $arg -le ${selector#-}
 509                                then
 510                                        include=$positive
 511                                fi
 512                                ;;
 513                        *-)
 514                                if test $arg -ge ${selector%-}
 515                                then
 516                                        include=$positive
 517                                fi
 518                                ;;
 519                        *-*)
 520                                if test ${selector%%-*} -le $arg \
 521                                        && test $arg -le ${selector#*-}
 522                                then
 523                                        include=$positive
 524                                fi
 525                                ;;
 526                        *)
 527                                if test $arg -eq $selector
 528                                then
 529                                        include=$positive
 530                                fi
 531                                ;;
 532                esac
 533        done
 534
 535        test -n "$include"
 536}
 537
 538maybe_teardown_verbose () {
 539        test -z "$verbose_only" && return
 540        exec 4>/dev/null 3>/dev/null
 541        verbose=
 542}
 543
 544last_verbose=t
 545maybe_setup_verbose () {
 546        test -z "$verbose_only" && return
 547        if match_pattern_list $test_count $verbose_only
 548        then
 549                exec 4>&2 3>&1
 550                # Emit a delimiting blank line when going from
 551                # non-verbose to verbose.  Within verbose mode the
 552                # delimiter is printed by test_expect_*.  The choice
 553                # of the initial $last_verbose is such that before
 554                # test 1, we do not print it.
 555                test -z "$last_verbose" && echo >&3 ""
 556                verbose=t
 557        else
 558                exec 4>/dev/null 3>/dev/null
 559                verbose=
 560        fi
 561        last_verbose=$verbose
 562}
 563
 564maybe_teardown_valgrind () {
 565        test -z "$GIT_VALGRIND" && return
 566        GIT_VALGRIND_ENABLED=
 567}
 568
 569maybe_setup_valgrind () {
 570        test -z "$GIT_VALGRIND" && return
 571        if test -z "$valgrind_only"
 572        then
 573                GIT_VALGRIND_ENABLED=t
 574                return
 575        fi
 576        GIT_VALGRIND_ENABLED=
 577        if match_pattern_list $test_count $valgrind_only
 578        then
 579                GIT_VALGRIND_ENABLED=t
 580        fi
 581}
 582
 583want_trace () {
 584        test "$trace" = t && test "$verbose" = t
 585}
 586
 587# This is a separate function because some tests use
 588# "return" to end a test_expect_success block early
 589# (and we want to make sure we run any cleanup like
 590# "set +x").
 591test_eval_inner_ () {
 592        # Do not add anything extra (including LF) after '$*'
 593        eval "
 594                want_trace && set -x
 595                $*"
 596}
 597
 598test_eval_ () {
 599        # We run this block with stderr redirected to avoid extra cruft
 600        # during a "-x" trace. Once in "set -x" mode, we cannot prevent
 601        # the shell from printing the "set +x" to turn it off (nor the saving
 602        # of $? before that). But we can make sure that the output goes to
 603        # /dev/null.
 604        #
 605        # The test itself is run with stderr put back to &4 (so either to
 606        # /dev/null, or to the original stderr if --verbose was used).
 607        {
 608                test_eval_inner_ "$@" </dev/null >&3 2>&4
 609                test_eval_ret_=$?
 610                if want_trace
 611                then
 612                        set +x
 613                        if test "$test_eval_ret_" != 0
 614                        then
 615                                say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
 616                        fi
 617                fi
 618        } 2>/dev/null
 619        return $test_eval_ret_
 620}
 621
 622test_run_ () {
 623        test_cleanup=:
 624        expecting_failure=$2
 625
 626        if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
 627                # turn off tracing for this test-eval, as it simply creates
 628                # confusing noise in the "-x" output
 629                trace_tmp=$trace
 630                trace=
 631                # 117 is magic because it is unlikely to match the exit
 632                # code of other programs
 633                if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
 634                then
 635                        error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
 636                fi
 637                trace=$trace_tmp
 638        fi
 639
 640        setup_malloc_check
 641        test_eval_ "$1"
 642        eval_ret=$?
 643        teardown_malloc_check
 644
 645        if test -z "$immediate" || test $eval_ret = 0 ||
 646           test -n "$expecting_failure" && test "$test_cleanup" != ":"
 647        then
 648                setup_malloc_check
 649                test_eval_ "$test_cleanup"
 650                teardown_malloc_check
 651        fi
 652        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 653        then
 654                echo ""
 655        fi
 656        return "$eval_ret"
 657}
 658
 659test_start_ () {
 660        test_count=$(($test_count+1))
 661        maybe_setup_verbose
 662        maybe_setup_valgrind
 663}
 664
 665test_finish_ () {
 666        echo >&3 ""
 667        maybe_teardown_valgrind
 668        maybe_teardown_verbose
 669}
 670
 671test_skip () {
 672        to_skip=
 673        skipped_reason=
 674        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 675        then
 676                to_skip=t
 677                skipped_reason="GIT_SKIP_TESTS"
 678        fi
 679        if test -z "$to_skip" && test -n "$test_prereq" &&
 680           ! test_have_prereq "$test_prereq"
 681        then
 682                to_skip=t
 683
 684                of_prereq=
 685                if test "$missing_prereq" != "$test_prereq"
 686                then
 687                        of_prereq=" of $test_prereq"
 688                fi
 689                skipped_reason="missing $missing_prereq${of_prereq}"
 690        fi
 691        if test -z "$to_skip" && test -n "$run_list" &&
 692                ! match_test_selector_list '--run' $test_count "$run_list"
 693        then
 694                to_skip=t
 695                skipped_reason="--run"
 696        fi
 697
 698        case "$to_skip" in
 699        t)
 700                say_color skip >&3 "skipping test: $@"
 701                say_color skip "ok $test_count # skip $1 ($skipped_reason)"
 702                : true
 703                ;;
 704        *)
 705                false
 706                ;;
 707        esac
 708}
 709
 710# stub; perf-lib overrides it
 711test_at_end_hook_ () {
 712        :
 713}
 714
 715test_done () {
 716        GIT_EXIT_OK=t
 717
 718        if test -z "$HARNESS_ACTIVE"
 719        then
 720                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 721                mkdir -p "$test_results_dir"
 722                base=${0##*/}
 723                test_results_path="$test_results_dir/${base%.sh}.counts"
 724
 725                cat >"$test_results_path" <<-EOF
 726                total $test_count
 727                success $test_success
 728                fixed $test_fixed
 729                broken $test_broken
 730                failed $test_failure
 731
 732                EOF
 733        fi
 734
 735        if test "$test_fixed" != 0
 736        then
 737                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
 738        fi
 739        if test "$test_broken" != 0
 740        then
 741                say_color warn "# still have $test_broken known breakage(s)"
 742        fi
 743        if test "$test_broken" != 0 || test "$test_fixed" != 0
 744        then
 745                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 746                msg="remaining $test_remaining test(s)"
 747        else
 748                test_remaining=$test_count
 749                msg="$test_count test(s)"
 750        fi
 751        case "$test_failure" in
 752        0)
 753                if test $test_external_has_tap -eq 0
 754                then
 755                        if test $test_remaining -gt 0
 756                        then
 757                                say_color pass "# passed all $msg"
 758                        fi
 759
 760                        # Maybe print SKIP message
 761                        test -z "$skip_all" || skip_all="# SKIP $skip_all"
 762                        case "$test_count" in
 763                        0)
 764                                say "1..$test_count${skip_all:+ $skip_all}"
 765                                ;;
 766                        *)
 767                                test -z "$skip_all" ||
 768                                say_color warn "$skip_all"
 769                                say "1..$test_count"
 770                                ;;
 771                        esac
 772                fi
 773
 774                test -d "$remove_trash" &&
 775                cd "$(dirname "$remove_trash")" &&
 776                rm -rf "$(basename "$remove_trash")"
 777
 778                test_at_end_hook_
 779
 780                exit 0 ;;
 781
 782        *)
 783                if test $test_external_has_tap -eq 0
 784                then
 785                        say_color error "# failed $test_failure among $msg"
 786                        say "1..$test_count"
 787                fi
 788
 789                exit 1 ;;
 790
 791        esac
 792}
 793
 794if test -n "$valgrind"
 795then
 796        make_symlink () {
 797                test -h "$2" &&
 798                test "$1" = "$(readlink "$2")" || {
 799                        # be super paranoid
 800                        if mkdir "$2".lock
 801                        then
 802                                rm -f "$2" &&
 803                                ln -s "$1" "$2" &&
 804                                rm -r "$2".lock
 805                        else
 806                                while test -d "$2".lock
 807                                do
 808                                        say "Waiting for lock on $2."
 809                                        sleep 1
 810                                done
 811                        fi
 812                }
 813        }
 814
 815        make_valgrind_symlink () {
 816                # handle only executables, unless they are shell libraries that
 817                # need to be in the exec-path.
 818                test -x "$1" ||
 819                test "# " = "$(head -c 2 <"$1")" ||
 820                return;
 821
 822                base=$(basename "$1")
 823                case "$base" in
 824                test-*)
 825                        symlink_target="$GIT_BUILD_DIR/t/helper/$base"
 826                        ;;
 827                *)
 828                        symlink_target="$GIT_BUILD_DIR/$base"
 829                        ;;
 830                esac
 831                # do not override scripts
 832                if test -x "$symlink_target" &&
 833                    test ! -d "$symlink_target" &&
 834                    test "#!" != "$(head -c 2 < "$symlink_target")"
 835                then
 836                        symlink_target=../valgrind.sh
 837                fi
 838                case "$base" in
 839                *.sh|*.perl)
 840                        symlink_target=../unprocessed-script
 841                esac
 842                # create the link, or replace it if it is out of date
 843                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 844        }
 845
 846        # override all git executables in TEST_DIRECTORY/..
 847        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 848        mkdir -p "$GIT_VALGRIND"/bin
 849        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
 850        do
 851                make_valgrind_symlink $file
 852        done
 853        # special-case the mergetools loadables
 854        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 855        OLDIFS=$IFS
 856        IFS=:
 857        for path in $PATH
 858        do
 859                ls "$path"/git-* 2> /dev/null |
 860                while read file
 861                do
 862                        make_valgrind_symlink "$file"
 863                done
 864        done
 865        IFS=$OLDIFS
 866        PATH=$GIT_VALGRIND/bin:$PATH
 867        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 868        export GIT_VALGRIND
 869        GIT_VALGRIND_MODE="$valgrind"
 870        export GIT_VALGRIND_MODE
 871        GIT_VALGRIND_ENABLED=t
 872        test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
 873        export GIT_VALGRIND_ENABLED
 874elif test -n "$GIT_TEST_INSTALLED"
 875then
 876        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 877        error "Cannot run git from $GIT_TEST_INSTALLED."
 878        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 879        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 880else # normal case, use ../bin-wrappers only unless $with_dashes:
 881        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 882        if ! test -x "$git_bin_dir/git"
 883        then
 884                if test -z "$with_dashes"
 885                then
 886                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 887                fi
 888                with_dashes=t
 889        fi
 890        PATH="$git_bin_dir:$PATH"
 891        GIT_EXEC_PATH=$GIT_BUILD_DIR
 892        if test -n "$with_dashes"
 893        then
 894                PATH="$GIT_BUILD_DIR:$PATH"
 895        fi
 896fi
 897GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 898GIT_CONFIG_NOSYSTEM=1
 899GIT_ATTR_NOSYSTEM=1
 900export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 901
 902if test -z "$GIT_TEST_CMP"
 903then
 904        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 905        then
 906                GIT_TEST_CMP="$DIFF -c"
 907        else
 908                GIT_TEST_CMP="$DIFF -u"
 909        fi
 910fi
 911
 912GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 913export GITPERLLIB
 914test -d "$GIT_BUILD_DIR"/templates/blt || {
 915        error "You haven't built things yet, have you?"
 916}
 917
 918if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
 919then
 920        echo >&2 'You need to build test-chmtime:'
 921        echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
 922        exit 1
 923fi
 924
 925# Test repository
 926TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 927test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 928case "$TRASH_DIRECTORY" in
 929/*) ;; # absolute path is good
 930 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 931esac
 932test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 933rm -fr "$TRASH_DIRECTORY" || {
 934        GIT_EXIT_OK=t
 935        echo >&5 "FATAL: Cannot prepare test area"
 936        exit 1
 937}
 938
 939HOME="$TRASH_DIRECTORY"
 940GNUPGHOME="$HOME/gnupg-home-not-used"
 941export HOME GNUPGHOME
 942
 943if test -z "$TEST_NO_CREATE_REPO"
 944then
 945        test_create_repo "$TRASH_DIRECTORY"
 946else
 947        mkdir -p "$TRASH_DIRECTORY"
 948fi
 949# Use -P to resolve symlinks in our working directory so that the cwd
 950# in subprocesses like git equals our $PWD (for pathname comparisons).
 951cd -P "$TRASH_DIRECTORY" || exit 1
 952
 953this_test=${0##*/}
 954this_test=${this_test%%-*}
 955if match_pattern_list "$this_test" $GIT_SKIP_TESTS
 956then
 957        say_color info >&3 "skipping test $this_test altogether"
 958        skip_all="skip all tests in $this_test"
 959        test_done
 960fi
 961
 962# Provide an implementation of the 'yes' utility
 963yes () {
 964        if test $# = 0
 965        then
 966                y=y
 967        else
 968                y="$*"
 969        fi
 970
 971        i=0
 972        while test $i -lt 99
 973        do
 974                echo "$y"
 975                i=$(($i+1))
 976        done
 977}
 978
 979# Fix some commands on Windows
 980uname_s=$(uname -s)
 981case $uname_s in
 982*MINGW*)
 983        # Windows has its own (incompatible) sort and find
 984        sort () {
 985                /usr/bin/sort "$@"
 986        }
 987        find () {
 988                /usr/bin/find "$@"
 989        }
 990        sum () {
 991                md5sum "$@"
 992        }
 993        # git sees Windows-style pwd
 994        pwd () {
 995                builtin pwd -W
 996        }
 997        # no POSIX permissions
 998        # backslashes in pathspec are converted to '/'
 999        # exec does not inherit the PID
1000        test_set_prereq MINGW
1001        test_set_prereq NATIVE_CRLF
1002        test_set_prereq SED_STRIPS_CR
1003        test_set_prereq GREP_STRIPS_CR
1004        GIT_TEST_CMP=mingw_test_cmp
1005        ;;
1006*CYGWIN*)
1007        test_set_prereq POSIXPERM
1008        test_set_prereq EXECKEEPSPID
1009        test_set_prereq CYGWIN
1010        test_set_prereq SED_STRIPS_CR
1011        test_set_prereq GREP_STRIPS_CR
1012        ;;
1013*)
1014        test_set_prereq POSIXPERM
1015        test_set_prereq BSLASHPSPEC
1016        test_set_prereq EXECKEEPSPID
1017        ;;
1018esac
1019
1020( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1021test -z "$NO_PERL" && test_set_prereq PERL
1022test -z "$NO_PYTHON" && test_set_prereq PYTHON
1023test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1024test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1025
1026# Can we rely on git's output in the C locale?
1027if test -n "$GETTEXT_POISON"
1028then
1029        GIT_GETTEXT_POISON=YesPlease
1030        export GIT_GETTEXT_POISON
1031        test_set_prereq GETTEXT_POISON
1032else
1033        test_set_prereq C_LOCALE_OUTPUT
1034fi
1035
1036# Use this instead of test_cmp to compare files that contain expected and
1037# actual output from git commands that can be translated.  When running
1038# under GETTEXT_POISON this pretends that the command produced expected
1039# results.
1040test_i18ncmp () {
1041        test -n "$GETTEXT_POISON" || test_cmp "$@"
1042}
1043
1044# Use this instead of "grep expected-string actual" to see if the
1045# output from a git command that can be translated either contains an
1046# expected string, or does not contain an unwanted one.  When running
1047# under GETTEXT_POISON this pretends that the command produced expected
1048# results.
1049test_i18ngrep () {
1050        if test -n "$GETTEXT_POISON"
1051        then
1052            : # pretend success
1053        elif test "x!" = "x$1"
1054        then
1055                shift
1056                ! grep "$@"
1057        else
1058                grep "$@"
1059        fi
1060}
1061
1062test_lazy_prereq PIPE '
1063        # test whether the filesystem supports FIFOs
1064        case $(uname -s) in
1065        CYGWIN*|MINGW*)
1066                false
1067                ;;
1068        *)
1069                rm -f testfifo && mkfifo testfifo
1070                ;;
1071        esac
1072'
1073
1074test_lazy_prereq SYMLINKS '
1075        # test whether the filesystem supports symbolic links
1076        ln -s x y && test -h y
1077'
1078
1079test_lazy_prereq FILEMODE '
1080        test "$(git config --bool core.filemode)" = true
1081'
1082
1083test_lazy_prereq CASE_INSENSITIVE_FS '
1084        echo good >CamelCase &&
1085        echo bad >camelcase &&
1086        test "$(cat CamelCase)" != good
1087'
1088
1089test_lazy_prereq UTF8_NFD_TO_NFC '
1090        # check whether FS converts nfd unicode to nfc
1091        auml=$(printf "\303\244")
1092        aumlcdiar=$(printf "\141\314\210")
1093        >"$auml" &&
1094        case "$(echo *)" in
1095        "$aumlcdiar")
1096                true ;;
1097        *)
1098                false ;;
1099        esac
1100'
1101
1102test_lazy_prereq AUTOIDENT '
1103        sane_unset GIT_AUTHOR_NAME &&
1104        sane_unset GIT_AUTHOR_EMAIL &&
1105        git var GIT_AUTHOR_IDENT
1106'
1107
1108test_lazy_prereq EXPENSIVE '
1109        test -n "$GIT_TEST_LONG"
1110'
1111
1112test_lazy_prereq USR_BIN_TIME '
1113        test -x /usr/bin/time
1114'
1115
1116test_lazy_prereq NOT_ROOT '
1117        uid=$(id -u) &&
1118        test "$uid" != 0
1119'
1120
1121test_lazy_prereq JGIT '
1122        type jgit
1123'
1124
1125# SANITY is about "can you correctly predict what the filesystem would
1126# do by only looking at the permission bits of the files and
1127# directories?"  A typical example of !SANITY is running the test
1128# suite as root, where a test may expect "chmod -r file && cat file"
1129# to fail because file is supposed to be unreadable after a successful
1130# chmod.  In an environment (i.e. combination of what filesystem is
1131# being used and who is running the tests) that lacks SANITY, you may
1132# be able to delete or create a file when the containing directory
1133# doesn't have write permissions, or access a file even if the
1134# containing directory doesn't have read or execute permissions.
1135
1136test_lazy_prereq SANITY '
1137        mkdir SANETESTD.1 SANETESTD.2 &&
1138
1139        chmod +w SANETESTD.1 SANETESTD.2 &&
1140        >SANETESTD.1/x 2>SANETESTD.2/x &&
1141        chmod -w SANETESTD.1 &&
1142        chmod -r SANETESTD.1/x &&
1143        chmod -rx SANETESTD.2 ||
1144        error "bug in test sript: cannot prepare SANETESTD"
1145
1146        ! test -r SANETESTD.1/x &&
1147        ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1148        status=$?
1149
1150        chmod +rwx SANETESTD.1 SANETESTD.2 &&
1151        rm -rf SANETESTD.1 SANETESTD.2 ||
1152        error "bug in test sript: cannot clean SANETESTD"
1153        return $status
1154'
1155
1156test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1157GIT_UNZIP=${GIT_UNZIP:-unzip}
1158test_lazy_prereq UNZIP '
1159        "$GIT_UNZIP" -v
1160        test $? -ne 127
1161'
1162
1163run_with_limited_cmdline () {
1164        (ulimit -s 128 && "$@")
1165}
1166
1167test_lazy_prereq CMDLINE_LIMIT 'run_with_limited_cmdline true'
1168
1169build_option () {
1170        git version --build-options |
1171        sed -ne "s/^$1: //p"
1172}
1173
1174test_lazy_prereq LONG_IS_64BIT '
1175        test 8 -le "$(build_option sizeof-long)"
1176'